Exec:

	clr.w		-(a7)
	clr.l		Flag

	bsr		PointeSurLeHandleDuDossier
	lea		2(a0),a0
	move.l		#ChaineTemporaire,a1
	bsr		CopieNomDeFichierOuDossier
	
	bsr		PointeSurLeHandleDuFichier
	move.l		#ChaineTemporaire2,a1
	bsr		CopieNomDeFichierOuDossier

	bsr		PointeSurFichier
	clr.l		d0
	move.w		(a0),d0
	lea		1(a0,d0.l),a4			; le genre
	cmp.b		#TypeAutre,(a4)
	bne		PasUnPPG
	move.l		#chaine_non_exe,a3
	cmp.w		#'TP',4(a0)			; est-ce un ppg ?
	bne		AfficheCommentSortieExec
	
	move.l		#chaine_ttstart_nom,a0
	move.l		a0,Flag
	addq.l		#1,Flag
	bsr		ChercheFichierDansRep
	move.l		#chaine_ttstart_notfound,a3
	tst.w		d0				; ttstart dans main ?
	beq		AfficheCommentSortieExec

	cmp.l		AdresseArchive,a0
	blt		ttstartEnRAM
	move.w		#$FFFF,(a7)
ttstartEnRAM:
	
	move.l		#chaine_ttstart,a0
	bra		LanceExecution
PasUnPPG:
	cmp.b		#TypeASM,(a4)
	bne		PasUnASM

	bsr		PointeSurFichier
	cmp.l		#'68kP',6(a0)			; (68kP ?)
	beq		ProgKernel
	move.l		#chaine_lib_notexe,a3
	cmp.l		#'68kL',6(a0)			; (68kL ?)
	beq		AfficheCommentSortieExec
	cmp.l		#'68cA',4(a0)
	bne		PasProgKernel
ProgKernel:
	move.l		#chaine_kernel_needed,a3
	tst.w		$30				; Kernel installe ?
	beq		AfficheCommentSortieExec
PasProgKernel:
	move.l		#chaine_explorer_open,a3
	cmp.l		#'ExPl',6+20(a0)
	beq		AfficheCommentSortieExec
	bsr		PointeSurFichier
	cmp.l		AdresseArchive,a0
	blt		ProgrammeEnRAM
	move.w		#$FFFF,(a7)
ProgrammeEnRAM:
	bsr		PointeSurLeHandleDuDossier
	lea		2(a0),a0
	move.l		#ChaineTemporaire3,a1
	bsr		CopieNomDeFichierOuDossier
	move.b		#92,-1(a1)			; Caractere "\"
	move.l		a1,-(a7)
	bsr		PointeSurLeHandleDuFichier
	move.l		(a7)+,a1

	bsr		CopieNomDeFichierOuDossier
	move.l		a1,Flag

	move.l		#chaine_prog,a0
	bra		LanceExecution
PasUnASM:
	move.l		#chaine_non_exe,a3
	cmp.b		#TypeSTR,(a4)
	bne		AfficheCommentSortieExec
	cmp.w		#'CP',2(a0)
	bne		AfficheCommentSortieExec
	move.l		#chaine_kernel_needed,a3
	tst.w		$30				; Kernel installe ?
	beq		AfficheCommentSortieExec

	move.l		#chaine_runc_nom,a0
	move.l		a0,Flag
	addq.l		#1,Flag
	bsr		ChercheFichierDansRep
	move.l		#chaine_runc_notfound,a3
	tst.w		d0				; runc sur la calc ?
	beq		AfficheCommentSortieExec
	cmp.l		AdresseArchive,a0
	blt		RunCEnRAM
	move.w		#$FFFF,(a7)
RunCEnRAM:

	move.l		#chaine_runc,a0
LanceExecution:

	bsr		SynchronisationVerticale
	bsr		NettoyeEcranGray
	bsr		SynchronisationVerticale
	bsr		GrayScalesOff

	pea		ChaineTemporaire2
	pea		ChaineTemporaire
	move.l		a0,-(a7)
	pea		ChaineTemporaireExec
	CALL		sprintf
	lea		4*4(a7),a7

	move.l		#ChaineTemporaireExec,-(a7)
	CALL		push_parse_text
	CALL		HS_popEStack
	lea		4(a7),a7


	movem.l		d0-d7/a0-a6,-(a7)
	clr.w		-(a7)
	move.w		d0,-(a7)
	CALL		NG_execute
	lea		2*2(a7),a7
	movem.l		(a7)+,d0-d7/a0-a6


	move.w		d0,-(a7)
	CALL		HeapFree
	lea		2(a7),a7

	CALL		OSTimerRestart

	cmp.w		#0,(a7)
	beq		FinExec
	move.l		Flag,d0
	beq		FinExec
	clr.w		-(a7)
	sub.l		#1,Flag
	move.l		Flag,-(a7)
	CALL		SymFindPtr
	move.l		a0,-(a7)
	CALL		SymDelTwin
	lea		6+4(a7),a7


FinExec:
	bsr		GrayScalesOn
	SetFont		#1
	bsr		InitialiseEcran

	CALL		GKeyFlush		; Reset le clavier
	addq.l		#2,a7			; Remet le pointeur a sa place (2 octets pour le flag de l'archive)


	rts

PasExecutable:
	bra		FinExec


CopieNomDeFichierOuDossier:
	move.b		(a0)+,(a1)+
	bne		CopieNomDeFichierOuDossier
	rts
